/* -*- mode: c; coding: utf-8 -*- */
/* $Id$ */

#define NEED_CORR 1
#include "checker.h"

#include <errno.h>

static int
int_cmp_func(const void *p1, const void *p2)
{
  int v1 = *(const int*) p1;
  int v2 = *(const int*) p2;
  return (v1 < v2)?-1:(v1 > v2);
}

int checker_main(int argc, char **argv)
{
  char *txt = 0, *bptr, *eptr;
  size_t txtsz = 0;
  const unsigned char *s;
  unsigned char *p;
  int i, j, numcnt, corrval;
  int *numlist;

  // read the whole answer and remove space
  checker_read_file(1, &txt, &txtsz);
  s = (const unsigned char *) txt;
  p = xmalloc(txtsz + 1);
  for (i = 0, j = 0; i < txtsz; ++i) {
    if (s[i] > ' ' && s[i] != 127) {
      p[j++] = s[i];
    }
  }
  p[j] = 0;

  // replace ',' with ' '
  for (i = 0; i < j; ++i)
    if (p[i] == ',') p[i] = ' ';
  // remove trailing space
  if (j > 0 && p[j - 1] == ' ') --j;
  p[j] = 0;
  if (!j) fatal_PE("Введен пустой ответ");

  // check that only digits remain
  for (i = 0; i < j; ++i)
    if ((p[i] < '0' || p[i] > '9') && p[i] != ' ')
      fatal_PE("В ответе обнаружен знак, не являющийся цифрой");

  XCALLOC(numlist, j);
  numcnt = 0;
  bptr = eptr = p;
  while (*eptr) {
    errno = 0;
    numlist[numcnt++] = strtol(bptr, &eptr, 10);
    if (errno)
      fatal_PE("Неверная запись числа");
    bptr = eptr;
  }

  qsort(numlist, numcnt, sizeof(numlist[0]), int_cmp_func);

  i = 0;
  while (checker_read_corr_int("corrval", 0, &corrval) >= 0) {
    if (corrval != numlist[i])
      fatal_WA("Не совпало число %d (дан ответ: %d, правильно: %d)",
               i + 1, numlist[i], corrval);
    ++i;
  }
  if (i < numcnt) fatal_WA("Не совпало количество чисел");
  checker_OK();
}
