/* -*- mode: c; coding: utf-8 -*- */
/* $Id$ */

#define NEED_CORR 1
#include "checker.h"

int checker_main(int argc, char **argv)
{
  char *txt = 0;
  size_t txtsz = 0;
  const unsigned char *s;
  unsigned char *p;
  int i, j, wlen, corrwlen, corrlen;
  int *wbuf, *corrwbuf;
  unsigned char corrbuf[1024];

  // read the whole answer and remove space
  checker_read_file(1, &txt, &txtsz);
  s = (const unsigned char *) txt;
  p = xmalloc(txtsz + 1);
  for (i = 0, j = 0; i < txtsz; ++i) {
    if (s[i] > ' ' && s[i] != 127) {
      p[j++] = s[i];
    }
  }
  p[j] = 0;

  // replace ',' with ' '
  for (i = 0; i < j; ++i)
    if (p[i] == ',') p[i] = ' ';
  // remove trailing space
  if (j > 0 && p[j - 1] == ' ') --j;
  p[j] = 0;
  if (!j) fatal_PE("Введен пустой ответ");

  // check that only Russian letters appear in the answer
  // and downcase them
  XCALLOC(wbuf, j + 1);
  wlen = checker_utf8_to_ucs4_str(wbuf, p);
  for (i = 0; i < wlen; ++i) {
    if ((wbuf[i] >= 0x410 && wbuf[i] <= 0x44f)
        || wbuf[i] == 0x401 || wbuf[i] == 0x451) {
      wbuf[i] = checker_ucs4_tolower(wbuf[i]);
    } else if (wbuf[i] != ' ') {
      fatal_PE("В ответе обнаружен знак, не являющийся русской буквой");
    }
  }

  checker_read_buf_2(2, "correct", 1, corrbuf, sizeof(corrbuf), 0, 0);
  corrlen = strlen(corrbuf);
  XCALLOC(corrwbuf, corrlen + 1);
  corrwlen = checker_utf8_to_ucs4_str(corrwbuf, corrbuf);
  if (checker_strcmp_ucs4(corrwbuf, wbuf)) fatal_WA("Неправильный ответ");

  checker_OK();
}
